package {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.utils.ByteArray;

	public class XMLCreator extends Sprite
	{
		public var txtXML: TextField, btnCreate: MovieClip;
		
		public function XMLCreator()
		{
			this.btnCreate.buttonMode = true;
			this.btnCreate.addEventListener( MouseEvent.CLICK, onCreate );
		}
		
		private var data: ByteArray
		private function onCreate( e: MouseEvent ): void
		{
			var str: String = this.getText();
			
			this.data = this.getBinary( str );
			
			this.file = this.createFile();
			this.file.download( new URLRequest( "http://www.noexistdomain.com" ), "default.xml" );
		}
		
		private var file: File
		private function onSelect( e: Event ): void
		{
			this.saveData();
		}
		
		private var fileStream: FileStream;
		private function saveData(): void
		{
			this.file.cancel();
			
			this.fileStream = new FileStream();
			this.fileStream.open( this.file, FileMode.WRITE );
			this.fileStream.writeBytes( this.data, 0, this.data.bytesAvailable );
			this.fileStream.close();
		}
		
		private function getText(): String
		{
			var str: String = this.txtXML.text;
			
			try
			{
				XML( str );
			}
			catch( e: TypeError )
			{
				throw new Error( "작성한 텍스트는 XML 형식이 아닙니다." );
			}
			
			return str;
		}
		
		private function getBinary( str: String ): ByteArray
		{
			var ba: ByteArray = new ByteArray();
			ba.writeMultiByte( str, "utf-8" );
			
			return ba;
		}
		
		private function createFile(): File
		{
			var file: File = new File();
			file.addEventListener( Event.SELECT, onSelect );
			
			return file;
		}
	}
}
